<?php

class FEParserFunctions {

function registFEfunctionhook( &$parser ) {
        $parser->setFunctionHook( 'ucsc_gb_link', array( 'FEParserFunctions', 'ucsc_gb_link_render') );
        $parser->setFunctionHook( 'ncbo_onttree', array( 'FEParserFunctions', 'ncbo_onttree_render') );
        return true;
}

function langGetMagic( &$magicWords, $langCode ) {
    $magicWords['ucsc_gb_link'] = array( 0, 'ucsc_gb_link' );
    $magicWords['ncbo_onttree'] = array( 0, 'ncbo_onttree' );
    return true;
}


function ucsc_gb_link_render( &$parser, $param1 = '', $param2 = '', $param3 = '' ) {
# This is to get genome browser view
# parameter1: genomic position e.g. Hg19::chr1:1..30
# parameter2: URL for UCSC genome browser

$pos = preg_split("/(:|,|\.)/", $param1, null, PREG_SPLIT_NO_EMPTY);
$width = 500;

if($param2 != ''){
$site = rtrim($param2, "/");
}else{
$site = 'http://genome.ucsc.edu';
}

if($param3 != ''){
$width = $param3;
}

$imgtag = "<img src=\"".$site;
$linktag = "<a href=\"".$site;

if(count($pos) >= 4){
        if($pos[0] == 'Hg19'){
                $imgtag .= "/cgi-bin/hgRenderTracks?clade=mammal&org=Human&db=hg19&position=";
                $linktag .= "/cgi-bin/hgTracks?clade=mammal&org=Human&db=hg19&position=";
        }elseif($pos[0] == 'Mm9'){
                $imgtag .= "/cgi-bin/hgRenderTracks?clade=mammal&org=Mouse&db=mm9&position=";
                $linktag .= "/cgi-bin/hgTracks?clade=mammal&org=Mouse&db=mm9&position=";
        }

        $start = $pos[2] - $width;
        $end = $pos[3] + $width;

        $imgtag .= $pos[1]."%3A".$start."-".$end."&hgt.suggest=&hgt.suggestTrack=knownGene&pix=700\">";
        $linktag .= $pos[1]."%3A".$start."-".$end."&hgt.suggest=&hgt.suggestTrack=knownGene\" >";
}else{
        $imgtag .= "/images/title.jpg\">";
        $linktag .= "\">";
}

$outtxt = $linktag.$imgtag."</a>";
return array( $outtxt, 'isHTML' => true );

}


function ncbo_onttree_render( &$parser, $param1 = '', $param2 = '', $param3 = '' ) {
# This is to get ontology tree animation from NCBO
# parameter1: ontology id, defined on NCBO
# parameter2: ontology node id, e.g.CL:*******
# parameter3: Path for "BasicFlexoFiz.swf", default path used if no param assigned

if($param3 != '' ){
$srcurl = $param3;
}else{
$srcurl= "http://keg.cs.uvic.ca/ncbo/flexviz/BasicFlexoViz.swf";
}

$ontid = $param1;
$nodeid = $param2;

$outtxt = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" id="FlexoViz" width="100%" height="100%" codebase="http://fpdownload.macromedia.com/get/flashplayer/current/swflash.cab"><param name="movie" value="'.$srcurl.'" /><param name="quality" value="high" /><param name="bgcolor" value="#ffffff" /><param name="allowScriptAccess" value="always" /><embed src="'.$srcurl.'" bgcolor="#ffffff" width="750px" height="600px" name="FlexoViz" align="middle" play="true" loop="false" quality="high" allowScriptAccess="always" type="application/x-shockwave-flash" flashVars="widget=true&ontology='.$ontid.'&nodeid='.$nodeid.'&server=http://rest.bioontology.org/bioportal" pluginspage="http://www.adobe.com/go/getflashplayer"></embed></object>';

return array( $outtxt, 'isHTML' => true );

}


}

?>

